package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;


public class ConsumoPorServicoPage extends PageBase {

    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaConsumo = By.xpath("//span[text() = 'Consumo']");
    By acessaConsumoPorServico = By.xpath("//span[text() = 'Consumo por Serviço']");
    By limpaFiltro = By.xpath("//*[@zh-icon='no-border close-x']");
    By filtroUnidade = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon = 'no-border search']");
    By clicarCampoUnidade = By.xpath("//*[@id='NMFILIAL']/input");
    By inputUnidade = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By clicaUnidade0002 = By.xpath("//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By clicaUnidade0003 = By.xpath("//span[text() = '0003 | DEPOSITO BC 111']");
    By clicaUnidade0004 = By.xpath("//span[text() = '0004 | FARMACIA BC 121']");
    By clicaUnidade9999 = By.xpath("//span[text() = '9999 | DEPOSITO BC 129']");

    By clicaCampoServico = By.xpath("//*[@id='NMSERVICO']/input");
    By servicoUnidade0002 = By.xpath("//span[text() = '00003 | JANTAR']");
    By servicoUnidade0003 = By.xpath("//span[text() = '00002 | JANTA']");
    By servicoUnidade0004 = By.xpath("//span[text() = '00001 | RETIRADAS']");
    By servicoUnidade9999 = By.xpath("//span[text() = '00004 | DISTRIBUICAO']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaCampoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By tipoConsumo = By.xpath("//div[@data-zh-id='12493230851921139535695']//span[@class = 'current']");
    By consumoPerCapita = By.xpath("//div[@data-zh-id='12493230851921139535695']//ul[@class = 'list zh-new-select-list']//li[text() = 'Per Capita']");
    By opcaoconsumoFixo = By.xpath("//div[@data-zh-id='12493230851921139535695']//ul[@class = 'list zh-new-select-list']//li[text() = 'Fixo']");
    By diaConsumo = By.xpath("//div[@data-zh-id='12493230851216446346697']//span[@class = 'current']");
    By segundaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Segunda-Feira']");
    By tercaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Terça-Feira']");
    By quartaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Quarta-Feira']");
    By quintaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Quinta-Feira']");
    By sextaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Sexta-Feira']");
    By Sabado = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Sábado']");
    By Domingo = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Domingo']");
    By limpaDtInicioValidade = By.xpath("//div[@class = 'zh-select-date zh-field-DTCONSSERV']//span[@zh-icon= 'no-border close-x']");
    By limpaDtExcecao = By.xpath("//div[@class = 'zh-select-date zh-field-DATAEXCECAO']//span[@zh-icon= 'no-border close-x']");
    By dtInicioValidade = By.xpath("//input[@id = 'DTCONSSERV']");
    By btnCalendario = By.xpath("//span[@zh-icon='calendar']");
    By btnAdicionar = By.xpath("//a[@data-zh-title-tooltip = 'F2']");
    By msgEsperada = By.xpath("//span[text() = 'CREOSOTO']");
    By msgEsperada_2 = By.xpath("//span[text() = 'OLEO DE COPAIBA']");

    //Filtro de Produto
    By buscaProduto = By.xpath("//span[@zh-icon='no-border search']");
    By selecionaProduto = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By qtdProduto = By.xpath("//input[@id = 'QTCONSSERV']");
    By pontoDeEntrega = By.xpath("//div[@data-zh-id='12493230854082222163725']//span[@class='current']");
    By btnSim = By.xpath("//li[text() = 'Sim']");
    By opcaoCozinhaCentral = By.xpath("//div[@data-zh-id='12493230853450296414726']//span[@class = 'current']");
    By opcaoentregaDireta = By.xpath("//li[text() = 'Entrega Direta']");
    By opcaoDistribuicao = By.xpath("//li[text() = 'Distribuição']");
    By usoDaCentral = By.xpath("//input[@id = 'QTUTILCENTRAL']");
    By diaDeConsumo = By.xpath("//div[@data-zh-id='12493230852618700311728']//span[@class = 'current']");
    By opcaoSegundaFeira = By.xpath("//li[text() = 'Segunda-feira']");
    By opcaoTercaFeira = By.xpath("//li[text() = 'Terça-feira']");
    By opcaoQuartaFeira = By.xpath("//li[text() = 'Quarta-feira']");
    By opcaoQuintaFeira = By.xpath("//li[text() = 'Quinta-feira']");
    By opcaoSextaFeira = By.xpath("//li[text() = 'Sexta-feira']");
    By opcaoSabado = By.xpath("//li[text() = 'Sábado']");
    By opcaoDomingo = By.xpath("//li[text() = 'Domingo']");
    By opcaoFeriado = By.xpath("//li[text() = 'Feriado']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By carregaGrid = By.xpath("//div[@class = 'body-content']");

    //Aba Exceções
    By btnExcecoes = By.xpath("//a[text() = 'Exceções']");
    By dtExcecao = By.xpath("//input[@id = 'DATAEXCECAO']");
    By btnPontoEntrega = By.xpath("//div[@data-zh-id='1249323085417169779758']//span[@class='current']");
    By validaImportacaoExecao = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[1]/span");


    //Edição produto Exceção
    By selecionarProduto = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div");
    By clicaProdutoExecao = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[1]");
    By btnEditar = By.xpath("//a[@data-zh-title-tooltip = 'F3']");
    By btnExcluir = By.xpath("//a[@data-zh-title-tooltip = 'Ctrl+d']");
    By cozinhaCentral = By.xpath("//div[@data-zh-id='12493230852410174743311']//span[@class = 'current']");
    By confirmaMensagem = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'Sim']");
    By msgExclusao = By.xpath("//p[text() = 'Não há registros']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");
    By edicaoCampoPontoEntrega = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[5]/span");
    By edicaoCampoCozinhaCentral = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[6]/span");
    By campoQuantidade = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[3]/div");
    By edicaoCampoQuantidade = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[3]/div");
    By retornaCampoQuantidade = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[3]/div/input");
    
    
    // Aba Dia sem Consumo
    By clicarAno = By.xpath("//h3[@class = 'calendar-heading']");
    By selecionaMes = By.xpath("//*[@id='zh-calendar-DiaSemConsCalendar']/section/div/div/div[3]/div[4]/div");
    By btnDiaSemConsumo = By.xpath("//a[text() = 'Dias Sem Consumo']");
    By primeiroDiaSemConsumo = By.xpath("//div[@data-date = 08/05/2024']");
    By segundoDiaSemConsumo = By.xpath("//div[@data-date = '15/05/2024']");
    By opcaoConsumoDia = By.xpath("//section[@class = 'popup-container']//div[@data-zh-id='12493230852729638746782']//span[@class = 'current']");
    By diaConsumoFixo = By.xpath("//section[@data-ng-if='popupOpen']//*[@data-zh-id='12493230852089173430780']//div[@data-zh-id='12493230852729638746782']//ul[@class = 'list zh-new-select-list']//li[text() = 'Fixo']");
    By diaConsumoPerCapita = By.xpath("//section[@data-ng-if='popupOpen']//*[@data-zh-id='12493230852089173430780']//div[@data-zh-id='12493230852729638746782']//ul[@class = 'list zh-new-select-list']//li[text() = 'Per Capita']");

    //Alterar/Excluir Consumo

    By clicaProduto = By.xpath("//*[@id='grid-1249323085964931782718']//div[@class = 'tr cell1']");
    By clicarProduto = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[1]");
    By abaConsumo = By.xpath("//a[text() = 'Consumo']");
    By btnOk = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'OK']");
    By editaProduto_1 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[3]/div");
    By novaQtdProduto_1 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[3]/div/input");
    By editaProduto_2 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[3]/div");
    By NovaQtdProduto_2 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[3]/div/input");
    By qtdCentral = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[7]/div");
    By informaQtdCentral = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[7]/div/input");
    By excluirProduto = By.xpath("//li[@data-zh-id='12493230853982378352739']//a[@data-zh-title-tooltip]");

    By primeiroProduto = By.xpath("//div[@id='grid-1249323085964931782718']//div[@class = 'tr cell1']");
    By editarProduto_2 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]");
    By salvarAlteracoes = By.xpath("//*[text() = 'Salvar alterações']");

    //Consumo Per Capita
    By cozinhaCentralDistribuicao = By.xpath("//div[@data-zh-id='12493230852410174743311']//span[@class = 'current']");

    //Ações Importação Consumo
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnImportarConsumo = By.xpath("//span[text() = 'Importação de Consumo']");
    By btnExportarConsumo = By.xpath("//span[text() = 'Exportação de Consumo']");
    By btnSubstituirProduto = By.xpath("//span[text() = 'Substituição de Produto']");
    By tipoDeConsumo = By.xpath("//div[@data-zh-id='2201729922951263217848']//span[@class = 'current']");
    By opcaoconsumoPerCapita = By.xpath("//li[text() = 'Per Capita']");
    By consumoFixo = By.xpath("//div[@data-zh-id='12493230851921139535695']//li[text() = 'Fixo']");
    By diaImportacao = By.xpath("//div[@data-zh-id='2201729922612767889851']//span[@class = 'current']");
    By importaSegundaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Segunda-Feira']");
    By importaTercaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Terça-Feira']");
    By importaQuartaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Quarta-Feira']");
    By importaQuintaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Quinta-Feira']");
    By importaSextaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Sexta-Feira']");
    By importaSabado = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Sábado']");
    By importaDomingo = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Domingo']");
    By dadosExistentes = By.xpath("//div[@data-zh-id='220172992808612627852']//span[@class = 'current']");
    By opcaoSobrepor = By.xpath("//div[@data-zh-id='220172992808612627852']//li[text() = 'Sobrepor']");
    By btnAplicarFiltro = By.xpath("//div[@id = 'footer']//span[text() = 'Aplicar filtro']");
    By selecionaServico = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By marcarTodos = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By btnImportar = By.xpath("//span[text() = 'Importar']");
    By filtroServicoBusca = By.xpath("//div[@id = 'NMSERVICO']//span[@zh-icon='no-border search']");

    //Validando importação
    By msgEncontrada_1 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[1]/div[1]/span");
    By msgEncontrada_2 = By.xpath("//*[@id= 'grid-1249323085964931782718']/div[2]/div/div[2]/div[1]/span");
    By msgEncontrada_3 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[3]/div[1]/span");
    By msgEncontrada_4 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[4]/div[1]/span");
    By msgEncontrada_5 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div/div[1]/span");

    //Ações Exportar Consumo
    By btnExportar = By.xpath("//li[@data-zh-id='6580556122671439818830']//span[text() = 'Exportar']");
    By exportarDestino = By.xpath("//div[@id = 'NOMEIDTIPOCONS']");
    By exportaSegunda = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]");
    By exportaTerca = By.xpath("//*[@id='grid-9999']/div[2]/div/div[3]/div[1]");
    By exportaQuarta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[4]/div[1]");
    By exportaQuinta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[5]/div[1]");
    By exportaSexta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[6]/div[1]");
    By exportaSabado = By.xpath("//*[@id='grid-9999']/div[2]/div/div[7]/div[1]");
    By exportaDomingo = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]");
    By okExportaConsumo = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By confirmaExportacao = By.xpath("//li[@data-zh-id='6580556124178481369822']//span[text() = 'Confirmar']");

    //Substituir Produto
    By produtoOrigem = By.xpath("//div[@id = 'NMPRODORI']//span[@zh-icon='no-border search']");
    By opcaoTodosUnidade = By.xpath("//label[@for = 'zh-checkbox-T_NMFILIAL']//span[@zh-icon='checked no-border']");
    By campoUnidade = By.xpath("//div[@id = 'NMFILIAL']");
    By confirmaBusca = By.xpath("//*[@class='tr cell1']");
    By btnOK = By.xpath("//div[@class = 'zh-footer-right']//span[text() = 'Ok']");
    By opcaoTodosServico = By.xpath("//label[@for = 'zh-checkbox-T_NMSERVICO']//span[@zh-icon='checked no-border']");
    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");
    By campoTipoConsumo = By.xpath("//div[@data-zh-id='13049218833760544966901']//span[@class = 'current']");
    By exportaConsumoFixo = By.xpath("//li[text() = 'Fixo']");
    By exportaConsumoPerCapita = By.xpath("//li[text() = 'Per Capita']");
    By exportaConsumoAmbos = By.xpath("//li[text() = 'Ambos']");
    By diaConsumoTrocaProduto = By.xpath("//div[@name= 'IDTIPOCONS']");
    By trocaProdutoSegunda = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]");
    By trocaProdutoTerca = By.xpath("//*[@id='grid-9999']/div[2]/div/div[3]/div[1]");
    By trocaProdutoQuarta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[4]/div[1]");
    By trocaProdutoQuinta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[5]/div[1]");
    By trocaProdutoSexta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[6]/div[1]");
    By trocaProdutoSsabado = By.xpath("//*[@id='grid-9999']/div[2]/div/div[7]/div[1]");
    By trocaProdutoDomingo = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]");
    By produtoDestino = By.xpath("//div[@id= 'NMPRODDEST']//span[@zh-icon='no-border search']");
    By checkBoxSubstituirProduto = By.xpath("//*[@id='grid-13049218831525648582924']/div[1]/div/div/div[1]");
    By btnSubstituir = By.xpath("//li[@data-zh-id='1304921883889935404931']");

    //Importar Exceção
    By importaExcecao = By.xpath("//span[text() = 'Importação de Exceção']");
    By exportaExcecao = By.xpath("//span[text() = 'Exportação de Exceção']");
    By substituiExcecao = By.xpath("//span[text() = 'Substituição de Produto']");
    By diaConsumoExcecao = By.xpath("//div[@data-zh-id='2201729922612767889851']//span[@class = 'current']");
    By excecaoSegundaFeira = By.xpath("//li[text() = 'Segunda-Feira']");
    By excecaoTercaFeira = By.xpath("//li[text() = 'Terça-Feira']");
    By excecaoQuartaFeira = By.xpath("//li[text() = 'Quarta-Feira']");
    By excecaoQuintaFeira = By.xpath("//li[text() = 'Quinta-Feira']");
    By excecaoSextaFeira = By.xpath("//li[text() = 'Sexta-Feira']");
    By excecaoSabado = By.xpath("//li[text() = 'Sábado']");
    By excecaoDomingo = By.xpath("//li[text() = 'Domingo']");
    By excecaoFeriado = By.xpath("//li[text() = 'Feriado']");
    By checkboxExcecao = By.xpath("//label[@for = 'zh-checkbox-EXCECAO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxProdutoExcecao = By.xpath("//*[@id='grid-2201729922191976875870']/div[1]/div/div/div[1]");
    By dataExcecao = By.xpath("//div[@data-date = '18/10/2022']");
    By unidadeExcecao = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon='no-border search']");
    By servicoExcecao = By.xpath("//div[@id = 'NMSERVICO']//span[@zh-icon='no-border search']");
    By clicarServico = By.xpath("//div[@class = 'tr cell2']");
    By selecionaServicoFiltro = By.xpath("//div[@class = 'tr cell2 row-editing currentRow']");
    By produtoImportacaoExcecao = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[1]/span");



    //Exportar Exceção
    By checkBoxProdutoExportacao = By.xpath("//*[@id='grid-6580556123085755595808']/div[1]/div/div/div[1]");
    By btnConfirmar = By.xpath("//li[@data-zh-id='6580556124178481369822']//span[text() = 'Confirmar']");
    By marcaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By dadosExistentesExp = By.xpath("//div[@data-zh-id='6580556121193224773820']//span[@class = 'current']");
    By sobreporExportacao = By.xpath("//li[text() = 'Sobrepor']");
    By servicoSelecionado = By.xpath("//*[@id='grid-9000']/div[2]/div/div[2]");
    By marcaExcecao = By.xpath("//label[@for = 'zh-checkbox-EXCECAO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By validaProdutoExcecao = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[1]/span");
    By produtoCloretoSodio = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div[1]/div[1]/span");
    By produtoOleoCopaiba = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div[2]/div[1]/span");



    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div");
    By botaoPesquisarFiltro = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]");
    By campoProcurar = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By validaCadastroExcecao = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[2]/span");


    public void navegaTelaConsumoPorServico(){
        tempo();
        waitForElement(clicaMenu);
        tempo();
        click(clicaMenu);
        click(clicaPlanejamento);
        click(clicaConsumo);
        click(acessaConsumoPorServico);
        tempo();
    }

    public void realizarFiltro(String cdFilial,String tipoDeConsumo,String diaSemanaConsumo){
        tempo();
        tempo();
        click(limpaFiltro);
        tempo();
        clickPerform(clicarCampoUnidade);
        tempo();
        switch (cdFilial){
            case "0002":
            click(clicaUnidade0002);
            tempo();
            clickPerform(clicaCampoServico);
            tempo();
            click(servicoUnidade0002);
            break;

            case "0003":
                click(clicaUnidade0003);
                tempo();
                clickPerform(clicaCampoServico);
                tempo();
                click(servicoUnidade0003);
                break;

            case "0004":
                click(clicaUnidade0004);
                tempo();
                clickPerform(clicaCampoServico);
                tempo();
                click(servicoUnidade0004);
                break;

            case "9999":
                click(clicaUnidade9999);
                tempo();
                clickPerform(clicaCampoServico);
                tempo();
                click(servicoUnidade9999);
                break;
        }

        tempo();
        if (tipoDeConsumo == "Per Capita"){
            click(tipoConsumo);
            tempo();
            click(consumoPerCapita);
        }
        tempo();
        click(diaConsumo);
        tempo();
        switch (diaSemanaConsumo){
            case "Segunda":
            click(segundaFeira);
            break;
            case "Terça":
                click(tercaFeira);
                break;
            case "Quarta":
                click(quartaFeira);
                break;
            case "Quinta":
                click(quintaFeira);
                break;
            case "Sexta":
                click(sextaFeira);
                break;
        }
        tempo();
        click(limpaDtInicioValidade);
        tempo();
        clickPerformData(dtInicioValidade);
        sendKeys(dtInicioValidade, "15/05/2024");
        tempo();
        click(btnAdicionar);
        tempo();

    }

    public void adicionaProduto(String CDPRODUTO, String QTDPRODUTO, String TIPOCONSUMO, String IDTPREQPROD, String CDPRODUTO_1, String QTDPRODUTO_1) {
        click(btnAdicionar);
        tempo();
        click(buscaProduto);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        if (TIPOCONSUMO == "Fixo"){
            click(pontoDeEntrega);
        tempo();
        click(btnSim);
         }
        tempo();
        if (IDTPREQPROD == "Distribuicao") {
            click(opcaoCozinhaCentral);
            tempo();
            click(opcaoDistribuicao);
        }
        tempo();
        tempo();
        click(btnSalvar);
        tempo();
        click(btnAdicionar);
        tempo();
        click(buscaProduto);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDPRODUTO_1);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO_1);
        tempo();
        if (TIPOCONSUMO == "Fixo") {
            click(pontoDeEntrega);
            click(btnSim);
        }
        tempo();
        if (IDTPREQPROD == "Distribuicao") {
            click(opcaoCozinhaCentral);
            tempo();
            click(opcaoDistribuicao);
        }
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void adicionaNovoProduto(String CDPRODUTO, String QTDPRODUTO, String TIPOCONSUMO){
        click(diaConsumo);
        tempo();
        click(quartaFeira);
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDPRODUTO);
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        if (TIPOCONSUMO == "Fixo") {
            click(pontoDeEntrega);
            tempo();
            click(btnSim);
        }
        tempo();
        click(opcaoCozinhaCentral);
        tempo();
        click(opcaoentregaDireta);
        tempo();
        tempo();
        click(btnSalvar);
        tempo();
        tempo();


    }

    public String confirmaCadastro(){
        return getText(msgEsperada);
    }

    public String confirmaCadastro_2(){
        return getText(msgEsperada_2);

    }

    public void adicionaExcecao(String tipoDeConsumo, String CDPRODUTO, String QTDPRODUTO){
        click(btnExcecoes);
        tempo();
        if (tipoDeConsumo == "Per Capita"){
            click(tipoConsumo);
            tempo();
            click(consumoPerCapita);
        }
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        sendKeys(dtExcecao, "15/05/2024");
        tempo();
        click(btnExcecoes);
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String retornaProdutoExcecao(){
        return getText(validaCadastroExcecao);
    }

    public void edidaConsumodiaExcecao(String tipoConsumoExecao){
        tempo();
        click(btnExcecoes);
        tempo();
        if (tipoConsumoExecao == "Per Capita"){
            click(tipoConsumo);
            tempo();
            click(consumoPerCapita);
        }
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        sendKeys(dtExcecao, "15/05/2024");
        click(btnExcecoes);
        tempo();
        click(selecionarProduto);
        tempo();
        click(btnEditar);
        tempo();
        click(qtdProduto);
        clearAndSendKeys(qtdProduto,"20");
        tempo();
        click(btnPontoEntrega);
        tempo();
        click(btnSim);
        tempo();
        click(cozinhaCentral);
        tempo();
        click(opcaoDistribuicao);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnVoltar);
        tempo();
        click(campoQuantidade);
        tempo();
    }

    public String msgEncontradaQuantidadeConsumida(){
        click(edicaoCampoQuantidade);
        tempo();
        return getText(retornaCampoQuantidade);
    }

    public String msgEncontradaPontoEntrega(){

        return getText(edicaoCampoPontoEntrega);
    }

    public String msgEncontradaCozinhaCentral(){
        return getText(edicaoCampoCozinhaCentral);
    }

    public void apagaExcecao(String tipoConsumoExecao){
       /* tempo();
        if (tipoConsumoExecao == "Per Capita"){
            click(tipoConsumo);
            tempo();
            click(consumoPerCapita);
        }
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        sendKeys(dtExcecao, "15/05/2024");
        click(btnExcecoes);*/
        tempo();
        click(clicaProdutoExecao);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public String validaExclusao(){
        return getText(msgExclusao);

    }

    public void diaSemConsumo(){
        tempo();
        click(btnDiaSemConsumo);
        tempo();
        click(clicarAno);
        tempo();
        click(selecionaMes);
        tempo();
        click(primeiroDiaSemConsumo);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnSalvar);
        tempo();
        click(segundoDiaSemConsumo);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(opcaoConsumoDia);
        tempo();
        click(diaConsumoPerCapita);
        tempo();
        click(btnSalvar);
        tempo();
        tempo();

    }

   public void edicaoDiaSemConsumo(){
        tempo();
        click(btnDiaSemConsumo);
        click(clicarAno);
        tempo();
        click(selecionaMes);
        tempo();
        click(primeiroDiaSemConsumo);
        tempo();
        click(btnEditar);
        tempo();
        click(opcaoConsumoDia);
        tempo();
        click(diaConsumoFixo);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnVoltar);
        tempo();
        click(segundoDiaSemConsumo);
        tempo();
       click(btnEditar);
       tempo();
       click(opcaoConsumoDia);
       tempo();
       click(diaConsumoPerCapita);
       click(btnSalvar);
       tempo();
       click(btnVoltar);
       tempo();

    }

    public void apagaDiaSemConsumo(){
        tempo();
        click(btnDiaSemConsumo);
        tempo();
        click(clicarAno);
        tempo();
        click(selecionaMes);
        tempo();
        click(primeiroDiaSemConsumo);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(segundoDiaSemConsumo);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void alteraConsumoDia(String TIPOCONSMO){
       tempo();
       click(abaConsumo);
       tempo();
       click(clicaProduto);
       tempo();
       click(btnEditar);
       click(qtdProduto);
       clearAndSendKeys(qtdProduto,"0");
       tempo();
       click(opcaoCozinhaCentral);
       tempo();
       click(opcaoentregaDireta);
       tempo();
       if (TIPOCONSMO == "Fixo") {
           click(usoDaCentral);
           clearAndSendKeys(usoDaCentral, "5");

           tempo();
           click(btnSalvar);
           tempo();
           click(btnOk);
           click(qtdProduto);
           clearAndSendKeys(qtdProduto, "2");
           click(btnSalvar);
           tempo();
       }
         click(btnSalvar);
         tempo();
         click(btnOk);
         tempo();
           click(qtdProduto);
           clearAndSendKeys(qtdProduto, "6");

       click(btnSalvar);
       tempo();
       click(btnVoltar);
       tempo();
       click(editaProduto_1);
       clearAndSendKeys(novaQtdProduto_1,"5");
       tempo();
       click(carregaGrid);
       click(salvarAlteracoes);
       tempo();
       click(editarProduto_2);
       tempo();
       click(btnEditar);
       tempo();
       click(opcaoCozinhaCentral);
       tempo();
       click(opcaoDistribuicao);
       click(btnSalvar);
       tempo();
       click(btnVoltar);
       tempo();

    }

    public void excluirProdutos(){
        tempo();
        click(primeiroProduto);
        tempo();
        click(excluirProduto);
        click(confirmaMensagem);
        tempo();
        click(primeiroProduto);
        tempo();
        click(excluirProduto);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void importarConsumo(String CDFILIAL, String CDSERVFILI, String TIPOCONSUMO, String IDIMPORTACAO){
        tempo();
        click(btnAcoes);
        click(btnImportarConsumo);
        click(filtroUnidade);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDFILIAL);
        click(selecionaBusca);
        tempo();
        click(filtroServicoBusca);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDSERVFILI);
        tempo();
        click(selecionaServico);
        tempo();
        click(limpaDtInicioValidade);
        clickPerformData(dtInicioValidade);
        if (IDIMPORTACAO == "A") {
            clearAndSendKeys(dtInicioValidade, "18/10/2022");
            tempo();
            if (TIPOCONSUMO == "Per Capita") {
                click(tipoDeConsumo);
                tempo();
                click(opcaoconsumoPerCapita);
                tempo();
                click(diaImportacao);
                tempo();
                click(importaSextaFeira);
                tempo();
            }else {
                tempo();
                click(diaImportacao);
                tempo();
                click(importaSegundaFeira);
                tempo();
            }
        }else{
            clearAndSendKeys(dtInicioValidade, "15/05/2024");
            tempo();
            if (TIPOCONSUMO == "Per Capita") {
                click(tipoDeConsumo);
                tempo();
                click(opcaoconsumoPerCapita);
            }
            tempo();
            click(diaImportacao);
            tempo();
            click(importaQuartaFeira);
            tempo();
            click(dadosExistentes);
            tempo();
            click(sobreporExportacao);

        }
        click(btnAplicarFiltro);
        tempo();
        click(marcarTodos);
        tempo();
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
        tempo();
    }

    public String validaImportacaoProdCanfora(){
        return getText(msgEncontrada_1);
    }

    public String validaImportacaoProdTampa(){
        return getText(msgEncontrada_2);
    }

    public String validaImportacaoProdTampaFrasco(){
        return getText(msgEncontrada_3);
    }

    public String validaImportacaoProdOleo(){
        return getText(msgEncontrada_4);
    }

    public String validaImportacaoSobrepor(){
        return getText(msgEncontrada_5);
    }

    public void exportaConsumo(String CDFILIAL, String CDSERVFILI){
        tempo();
        click(btnAcoes);
        click(btnExportarConsumo);
        tempo();
        click(marcarTodos);
        tempo();
        click(btnExportar);
        tempo();
        click(filtroUnidade);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDFILIAL);
        tempo();
        click(selecionaBusca);
        tempo();
        click(filtroServicoBusca);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,CDSERVFILI);
        click(selecionaServico);
        tempo();
        click(limpaDtInicioValidade);
        clickPerformData(dtInicioValidade);
        sendKeys(dtInicioValidade, "15/05/2024");
        tempo();
        click(exportarDestino);
        tempo();
        click(exportaSegunda);
        click(exportaTerca);
        tempo();
        click(okExportaConsumo);
        tempo();
        click(confirmaExportacao);
        tempo();
        click(limpaFiltro);
        tempo();
        clickPerform(clicarCampoUnidade);
        tempo();
        click(clicaUnidade9999);
        tempo();
        clickPerform(clicaCampoServico);
        tempo();
        click(servicoUnidade9999);
        tempo();
        int i = 0;
        while( i < 3) {
            tempo();
            click(clicarProduto);
            tempo();
            click(excluirProduto);
            tempo();
            click(confirmaMensagem);
            i++;
        }
        tempo();
        Assert.assertEquals(validaExclusao(),"Não há registros","Exclusão consumo segunda-feira: ");
        tempo();
        click(diaConsumo);
        tempo();
        click(tercaFeira);
        tempo();
        int c = 0;
        while( c < 3) {
            tempo();
            click(clicarProduto);
            tempo();
            click(excluirProduto);
            tempo();
            click(confirmaMensagem);
            c++;
        }
        tempo();
        Assert.assertEquals(validaExclusao(),"Não há registros","Exclusão consumo terça-feira: ");
        tempo();

    }

    public void substituiProduto(){
        click(diaConsumo);
        tempo();
        click(segundaFeira);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnSubstituirProduto);
        tempo();
        click(produtoOrigem);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,"CANFORA");
        click(selecionaProduto);
        tempo();
        click(opcaoTodosUnidade);
        click(campoUnidade);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,"0002");
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(opcaoTodosServico);
        click(campoServico);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro,campoProcurar,"00002");
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(campoTipoConsumo);
        click(exportaConsumoFixo);
        tempo();
        clickPerformData(dtInicioValidade);
        sendKeys(dtInicioValidade, "15/05/2024");
        tempo();
        click(diaConsumoTrocaProduto);
        tempo();
        click(trocaProdutoSegunda);
        click(trocaProdutoTerca);
        click(btnOK);
        tempo();
        click(produtoDestino);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"101110100100");
        tempo();
        click(confirmaBusca);
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxSubstituirProduto);
        click(btnSubstituir);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public String validaProdutoImportacao(){
        return getText(validaImportacaoExecao);
    }

    public void importaExcecao(String tipoConsumoImportacao, String acaoDadosExistentes) {
        if (acaoDadosExistentes != "Sobrepor"){
        tempo();
        click(btnExcecoes);
        tempo();
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        clearAndSendKeys(dtExcecao, "15/05/2024");
        click(btnExcecoes);
        tempo();
        click(btnAcoes);
        click(importaExcecao);
        tempo();
        click(filtroUnidade);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "0003");
        click(selecionaBusca);
        tempo();
        click(filtroServicoBusca);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "00004");
        tempo();
        click(selecionaServico);
        tempo();
        click(limpaDtInicioValidade);
        clickPerformData(dtInicioValidade);
        sendKeys(dtInicioValidade, "04/12/2023");
        tempo();
        if (tipoConsumoImportacao == "Per Capita") {
            click(tipoDeConsumo);
            tempo();
            click(exportaConsumoPerCapita);
        }
        click(checkboxExcecao);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxProdutoExcecao);
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnExcecoes);
        tempo();
    }else{

            click(btnExcecoes);
            tempo();
            click(limpaDtExcecao);
            clickPerformData(dtExcecao);
            clearAndSendKeys(dtExcecao, "15/05/2024");
            click(btnExcecoes);
            click(btnAdicionar);
            click(buscaProduto);
            preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "101110100300");
            tempo();
            click(selecionaProduto);
            click(qtdProduto);
            sendKeys(qtdProduto, "2");
            tempo();
            click(btnSalvar);
            tempo();
            click(btnAcoes);
            click(importaExcecao);
            tempo();
            if (tipoConsumoImportacao == "Per Capita"){
                click(tipoDeConsumo);
                tempo();
                click(exportaConsumoPerCapita);
            }
            tempo();
            click(filtroUnidade);
            preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "0003");
            click(selecionaBusca);
            tempo();
            click(filtroServicoBusca);
            tempo();
            preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "00004");
            tempo();
            click(selecionaServico);
            tempo();
            click(limpaDtInicioValidade);
            clickPerformData(dtInicioValidade);
            sendKeys(dtInicioValidade, "04/12/2023");
            tempo();
            click(checkboxExcecao);
            tempo();
            click(dadosExistentes);
            tempo();
            click(opcaoSobrepor);
            tempo();
            click(btnAplicarFiltro);
            tempo();
            click(checkBoxProdutoExcecao);
            click(btnImportar);
            tempo();
            click(confirmaMensagem);
            tempo();
            click(btnExcecoes);
            tempo();

         //   apagaExcecao("Per Capita");
            tempo();
        }

    }

    public String retornaProdutoImportacaoExcecao(){
        return getText(produtoImportacaoExcecao);
    }

    public void exportarExcecao(String acaoDadosExistentes){
        tempo();
        click(btnExcecoes);
        tempo();
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        if (acaoDadosExistentes != "Sobrepor") {
            clearAndSendKeys(dtExcecao, "04/12/2023");
        }else {
            clearAndSendKeys(dtExcecao, "15/05/2024");
        }
        click(btnExcecoes);
        click(btnAcoes);
        tempo();
        click(exportaExcecao);
        tempo();
        click(checkBoxProdutoExportacao);
        click(btnExportar);
        tempo();
        click(unidadeExcecao);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "9999");
        tempo();
        click(confirmaBusca);
        tempo();
        click(servicoExcecao);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "0004");
        tempo();
        click(selecionaBusca);
        tempo();
        click(limpaDtInicioValidade);
        clickPerformData(dtInicioValidade);
        sendKeys(dtInicioValidade, "15/05/2024");
        tempo();
        if (acaoDadosExistentes == "Sobrepor"){
            click(dadosExistentesExp);
            tempo();
            click(sobreporExportacao);
        }
        tempo();
        click(btnConfirmar);
        tempo();
        realizarFiltro("9999","Fixo","Segunda");
        tempo();
        click(btnExcecoes);
        tempo();
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        sendKeys(dtExcecao, "15/05/2024");
        click(btnExcecoes);
        tempo();
    }

    public String retornaProdutoCloretoSodio(){
        return getText(produtoCloretoSodio);
    }

    public String retornaProdutoOleoCopaiba(){
        return getText(produtoOleoCopaiba);
    }

    public String msgEncontradaProdExecao(){
        return getText(validaProdutoExcecao);
    }

    public void substituiProdutoExcecao(String CDPRODORIG, String CDPRODNOVO){
        tempo();
        click(btnExcecoes);
        tempo();
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        clearAndSendKeys(dtExcecao, "15/05/2024");
        click(btnExcecoes);
        click(btnAcoes);
        tempo();
        click(btnSubstituirProduto);
        tempo();
        click(produtoOrigem);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, CDPRODORIG);
        tempo();
        click(selecionaProduto);
        tempo();
        click(opcaoTodosUnidade);
        click(campoUnidade);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "0002");
        tempo();
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(opcaoTodosServico);
        click(campoServico);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, "00002");
        tempo();
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(campoTipoConsumo);
        click(exportaConsumoFixo);
        tempo();
        clickPerformData(dtInicioValidade);
        sendKeys(dtInicioValidade, "15/05/2024");
        tempo();
        click(marcaExcecao);
        tempo();
        click(produtoDestino);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, CDPRODNOVO);
        tempo();
        click(confirmaBusca);
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxSubstituirProduto);
        click(btnSubstituir);
        tempo();
        click(confirmaMensagem);
        tempo();
        int j = 0;
        while( j < 3) {
            click(clicarProduto);
            click(excluirProduto);
            click(confirmaMensagem);
            j++;
        }
        tempo();
        click(btnExcecoes);
        tempo();
        click(limpaDtExcecao);
        clickPerformData(dtExcecao);
        clearAndSendKeys(dtExcecao, "15/05/2024");
        click(btnExcecoes);
        tempo();

    }

}
