package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.CadastroTipoDePratoPage;

public class CadastroTipoDePratoFlows {
    CadastroTipoDePratoPage cadastroTipoDePratoPage = new CadastroTipoDePratoPage();

    public void navegaTipoDePrato(){
        cadastroTipoDePratoPage.clicarMenuPrincipal();
    }

    public void cadastraTipoPrato(String codigo, String nome, String nomeReduzido, String nmGrupo){
        cadastroTipoDePratoPage.adicionaTipoDePrato(codigo,nome,nomeReduzido, nmGrupo);
    }

    public String msgEncontradaCadastro(){ return cadastroTipoDePratoPage.confirmaCadastro(); }

    public String msgEncontrada(){return cadastroTipoDePratoPage.mensagemEsperada();}

    public void alteraTipodePrato(String novoNome, String nomeReduzido,String cdNovoGrupo){
        cadastroTipoDePratoPage.alteraTipoDePrato( novoNome,nomeReduzido, cdNovoGrupo);
    }

    public void excluirTipoDePratoRelacionado(){
        cadastroTipoDePratoPage.excluirTipodePratoRelacionado();
    }

    public String validarExclusao(){return cadastroTipoDePratoPage.validarExclusaoRelac();}

    public void excluirTipoPrato(){cadastroTipoDePratoPage.excluirTipoPrato();}

    public String msgEncontradaExclusao(){return cadastroTipoDePratoPage.confirmaExclusao();}

    public void camposObrigatorios(){cadastroTipoDePratoPage.validarCampoObrigatorio();}









}
