package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.GrupoTipodePratoPage;

public class GrupoTipodePratoFlows {

    GrupoTipodePratoPage grupoTipodePratoPage;

    public GrupoTipodePratoFlows(){
        grupoTipodePratoPage = new GrupoTipodePratoPage();
    }

    public void navegarParaGrupoTipodePrato(){grupoTipodePratoPage.acessarTela();}

    public void validarCamposObrigatorios(String CDCODIGO, String NMGRUPO){grupoTipodePratoPage.validaCamposObrigatorio(CDCODIGO,NMGRUPO);}

    public void insereGrupo(String CDCODIGO, String NMGRUPO){grupoTipodePratoPage.insereGrupoTipoPrato(CDCODIGO,NMGRUPO);}

    public String retornaCadastroGrupo(){return grupoTipodePratoPage.retornaCadastroGrupo();}

    public String retornaCadastroGrupo2(){return grupoTipodePratoPage.retornaCadastroGrupo2();}

    public void validaInsercaoRegistroIgual(String CDCODIGO, String NMGRUPO){grupoTipodePratoPage.validaRegistroIgual(CDCODIGO,NMGRUPO);}

    public void salvarRegistroSemNome(){grupoTipodePratoPage.salvarSemNome();}

    public void editarESalvarRegistro(String NMGRUPO01, String NMGRUPO02){grupoTipodePratoPage.editarESalvar(NMGRUPO01,NMGRUPO02);}

    public String mensagemEncontrada01(){return grupoTipodePratoPage.validaCadastroGrupo01();}

    public String mensagemEncontrada02(){return grupoTipodePratoPage.validaCadastroGrupo02();}

    public void apagaRegistroRelacionado(){grupoTipodePratoPage.excluirRegistroRelacionado();}

    public void apagarRegistroGuarnicao(){grupoTipodePratoPage.excluirRegistroGuarnicao();}

    public void apagarRegistroSalada(){grupoTipodePratoPage.excluirRegistroSalada();}

    public String validarExclusao(){return grupoTipodePratoPage.validaExclusao();}
}
