package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class ElaboraCardapioPage extends PageBase {



    By ClicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaProcurarTela = By.xpath("/html/body/span[1]/section/section/div[2]/section[1]/div/aside/div[1]/section/input");
    By clicaPlanejamento = By.xpath("//li[@class = 'menu-item visible']//span[text() = 'Elaboração do Cardápio']");
    By msgEncontrata = By.xpath("//*[@id='header']/div/div[2]/div[2]");
    By btnLimpaCampo = By.xpath("//div[@id = 'NMFILIAL']//span[@class = 'zh-icon zh-icon-close-x zh-icon-no-border']");
    By lupaFilial = By.xpath("//*[@id = 'NMFILIAL']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By msgAlerta = By.xpath("//footer[@class = 'zh-footer-alert']//span[contains(text(),'OK')]");
    By confirmaFilial = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By btnConfirmar = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By msgEsperada = By.xpath("//*[@id='header']/div/div[2]/div[2]");
    By filtroServico = By.xpath("//div[@id = 'NMSERVICO']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By informaServico = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By confirmaServico = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By preencheFilial = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");

    By limpaDataCardapio = By.xpath("//div[@name = 'dataCardapio']//span[@zh-icon='no-border close-x']");
    By campoData = By.xpath("//div[@id = 'dataCardapio']");
    By avancaPeriodo = By.xpath("//div[@class = 'arrow-right zh-icon zh-icon-forward zh-icon-no-border']");
    By periodoCardapio = By.xpath("//div[@class= 'month']//*[contains(text(),'Abr')]");

    //Montagem através de:

    By radioPercentualConsumo = By.xpath("//label[@for = 'radio-tipoComensais-P']/div");
    By radioNumeroComensais = By.xpath("//label[@for = 'radio-tipoComensais-C']/div");
    By checkBoxArredondaNumeroComensais = By.xpath("//label[@for = 'zh-checkbox-arredondarComensais']/div[1]");


    //campo custo planejado
    By limpaCustoPla = By.xpath("//div[@id = 'NMCUSTOPLANEJADO']//span[@zh-icon = 'no-border close-x']");
    By campoCustoPla = By.xpath("//div[@id = 'NMCUSTOPLANEJADO']");
    By lupaCustoPla = By.xpath("//*[@id='NMCUSTOPLANEJADO']/span");
    By informaCustoPla = By.xpath("//*[@id='popup']/span/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaCustoPla = By.xpath("//*[@id='popup']/span/section/section/section/div/div[1]/ul/li[2]/div/div/span");

    //campo custo realizado
    By limpaCustoReal = By.xpath("//div[@id = 'NMCUSTOREALIZADO']//span[@zh-icon = 'no-border close-x']");
    By campoCustoReal = By.xpath("//div[@id= 'NMCUSTOREALIZADO']");
    By lupaCustoReal = By.xpath("//div[@id= 'NMCUSTOREALIZADO']/span");
    By informaCustoReal = By.xpath("//*[@id='popup']/span/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaCustoReal = By.xpath("//*[@id='popup']/span/section/section/section/div/div[1]/ul/li[2]/div/div/span");
    By exibeCustoCardapio = By.xpath("//div[@data-zh-id='3931100361415493489953']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By dtCardapio = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[3]/div[1]/div/div[2]/label/div");
    By dtReferencia = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[3]/div[1]/div/div[3]/label/div");
    By limpaDtReferencia = By.xpath("//div[@class = 'close-button']");
    By inputDtReferencia = By.xpath("//input[@name = 'dataReferencia']");
    By limpaDataReferencia = By.xpath("//div[@class= 'zh-select-date zh-field-dataReferencia']//span[@zh-icon = 'no-border close-x']");

    //Mensagens campo obrigatório filtro elaboração
    By msgCampoUnidade = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[1]/div/div[1]/div/div/div[2]/span");
    By msgCampoServico = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[1]/div/div[2]/div/div/div[2]/span");
    By msgCampoMesCardapio = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[1]/div/div[3]/div/div/div[2]/span");
    By msgCustoPla = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[1]/div[1]/div/div[2]/span");
    By msgCustoReal = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[1]/div[2]/div/div[2]/span");
    By msgCampoDataRef = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[3]/div[2]/div/div[2]/span");


    //Elaborando Cardápio
    By tipoPrato01 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[3]");
    By tipoPrato02 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[4]");
    By tipoPrato03 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[5]");
    By tipoPRato04 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[3]");
    By tipoPrato05 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[2]/div[3]");
    By pratoRevisaoLocal = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[4]");
    By nmPrato = By.xpath("//*[@id='PRATOINI']");
    By clicarGrid = By.xpath("//div[@id = 'grid-21154635372457805457423']//div[@class = 'body-content']");
    By clicaPrato = By.xpath("//*[@id='grid-21154635374273353301405']/div[2]/div/div");
    By copiarSubsPratoSeg = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[1]/div[2]/div/label/div");
    By copiarSubsPratoTer = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[1]/div[3]/div/label/div");
    By copiarSubsPratoQua = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[1]/div[4]/div/label/div");
    By copiarSubsPratoQuin = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[2]/div[1]/div/label/div");
    By copiarSubsPratoSex = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[2]/div[2]/div/label/div");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By btnAcoes = By.xpath("//li[@class='more-actions zh-ripple-effect']");
    By btnCancelar = By.xpath("//*[@id='footer']/div[1]/ul/li");

    //Analise de cor cardápio
    By analiseCor = By.xpath("//span[text() = 'Análise de Cor']");
    By corPratoCardapio = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[3]");
    By validaCorCardapio = By.xpath("//div[@id='grid-21154635373500446320972']//div[@class='crosstab-body-content']/div[25]//div[@data-zh-field-name='NRSEQCNFMES_2']");

    //Analise de Custo
    By analiseCusto = By.xpath("//span[text() =  'Análise de Custos']");
    By abaPlanejado = By.xpath("//a[text() = 'Planejado']");
    By abaRealizado = By.xpath("//a[text() =  'Realizado']");
    By abaAcompanhamento = By.xpath("//a[text() =  'Acompanhamento']");
    By abaProdCustoZero = By.xpath("//a[text() =  'Produtos Custo Zero']");
    By clicaDiaAnalise = By.xpath("//*[@id='grid-158134869238991976091062']/div[2]/div/div[1]");
    By materiaPrima = By.xpath("//a[text() = 'Matéria Prima']");
    By consumoPorServico = By.xpath("//a[text() = 'Consumo por Serviço']");
    By clicaTipopratoConsumo = By.xpath("//*[@id='grid-15813486925486828631110']/div[2]/div/div[1]/div[1]");
    By clicaTipoPratoConsumo = By.xpath("//div[@ id='grid-15813486925486828631110']//div[@class='tr cell2 colorline']");
    By clicaPratoMateriaPrima = By.xpath("//*[@id='grid-158134869215106118231064']/div[2]/div/div");


    //Atualiza Data de Referência
    By atualizaDataRef = By.xpath("//span[text() = 'Atualizar Data de Referência para Custos']");
    By btnTodos = By.xpath("//span[@class = 'zh-icon zh-icon-checked zh-icon-no-border']");
    By campoServico = By.xpath("//*[@id='NMSERVICO']");
    By confirmServico = By.xpath("//span[@data-ng-if='!row.__group']");
    By btnOk = By.xpath("//span[text() = 'Ok']");
    By limpaDataRef = By.xpath("//div[@class = 'close-button']");
    By calendarDtRef = By.xpath("//span[@class = 'zh-icon zh-icon-calendar zh-icon-no-border']");
    By insereDataReferencia = By.xpath("//input[@id = 'DTREFERENCIA']");
    By selecionaDtReferencia = By.xpath("//div[text()= '19']");
    By btnAtualizar = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By confirmaDataReferencia = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sim']");
    By botaoOkMsg = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'OK']");

    //Atualizar Data de Referência para Recálculo de Custos
    By btnAtualizaDtRecalculoCusto = By.xpath("//span[text() = 'Atualizar Data de Referência para Recálculo de Custos']");

    // Consulta Nutrientes
    By btnConsulaNutriente = By.xpath("//span[text() = 'Consultar Nutrientes']");
    By btnCalculaNutriente = By.xpath("//li[@data-zh-id='82955748940826254151552']//div[@class = 'zh-test-box']");
    By btnVoltar = By.xpath("//*[@id='footer']/div[1]/ul/li/a/span");
    By btnCalendario = By.xpath("//li[@data-zh-id='82955748928579975681556']//div[@class = 'zh-test-box']");
    By diaCalculoNutriente = By.xpath("//section[@class = 'popup-content']//span[text() = '03/04/2024']");

    // Copia Pratos e Comensais
    By btnCopiaPratoComensais = By.xpath("//span[text() = 'Copiar Pratos e Comensais']");
    By limpaCampoServico = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMPRATO zh-text-align-left']");
    By lupaPratoOrigem = By.xpath("//span[@zh-icon='no-border search']");
    By informaPrato = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaPrato = By.xpath("//*[@id='grid-9000']/div[2]/div/div");
    By checkBoxSobreporPratos = By.xpath("//div[@data-zh-id='21154635373442535691254']//span[@class = 'zh-icon zh-icon-check");
    By comensaisSeg = By.xpath("//input[@id = 'COMENSAISSEG']");
    By comensaisTer = By.xpath("//input[@id = 'COMENSAISTER']");
    By comensaisSQuar = By.xpath("//input[@id = 'COMENSAISQUA']");
    By comensaisQuin = By.xpath("//input[@id = 'COMENSAISQUI']");
    By comensaisSex = By.xpath("//input[@id = 'COMENSAISSEX']");
    By comensaisSab = By.xpath("//input[@id = 'COMENSAISSAB']");
    By comensaisDom = By.xpath("//input[@id = 'COMENSAISDOM']");
    By comensaisFer = By.xpath("//input[@id = 'COMENSAISFER']");
    By btnCopiarPratos = By.xpath("//li[@data-zh-id='21154635373354322134257']");
    By btnCopiaComensais = By.xpath("//li[@data-zh-id='2115463537806145373259']");
    By confirmaMensagem = By.xpath("//*[@class = 'zh-footer-alert']");


    //Exportar Cardápio
    By btnExportarCardapio = By.xpath("//span[text() = 'Exportar Cardápio']");
    By btnProximoMes = By.xpath("//div[@class = 'arrow-right zh-icon zh-icon-forward zh-icon-no-border']");
    By periodoInicial = By.xpath("//div[@class = 'day']//div[text() = '1']");
    By periodoFinal = By.xpath("//div[@class = 'day']//div[text() = '30']");
    By dtInicialExportacao = By.xpath("//input[@id = 'DTINTERVAL_START']");
    By dtFinalExportacao = By.xpath("//input[@id = 'DTINTERVAL_END']");
    By checkBoxCopiarComOrig = By.xpath("//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By radioButtonSobrepor = By.xpath("//label[@for = 'radio-ACRESCSOBRE-S']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By campoGrupo = By.xpath("//div[@id= 'NMGRUPSERV']");
    By marcaServicoDestino = By.xpath("//*[@id='grid-2115463537811085471318']/div[1]/div/div/div[1]");
    By btnExportar = By.xpath("//*[text() ='Exportar']");
    By limpaFiltroServico = By.xpath("//div[@id = 'NMSERVICO']//span[@zh-icon='no-border close-x']");
    By clicaAno = By.xpath("//h3[@class = 'calendar-heading']");
    By mudaAnoImportacao = By.xpath("//*[@id='popup']/span/section/section/section/div/section/nav/header/div[2]");
    By selecionaMesDestinoExportacao = By.xpath("//div[text() = 'Abr']");



    //Importar Cardápio do Dia
    By btnImportarCardapio = By.xpath("//span[text() = 'Importar Cardápio do Dia']");
    By informaFilial = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaFilial = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By dtInicialOrigem = By.xpath("//input[@id = 'DATAORIGEMINICIAL']");
    By dtFinalOrigem = By.xpath("//input[@id = 'DATAORIGEMFINAL']");
    By dtDestino = By.xpath("//input[@id = 'DATADESTINO']");
    By radioSobrepor = By.xpath("//label[@for = 'radio-MONTAGEM-S']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By btnFiltrar = By.xpath("//section[@class= 'popup-container']//div[@id = 'footer']//li[@data-zh-id='97373962911923200311585']//span[text() = 'Filtrar']");
    By btnImportar = By.xpath("//li[@data-zh-id='9737396299038390791597']");

    //Importa tipo de prato

    By btnImportaTipoPrato = By.xpath("//span[text() = 'Importar Tipo de Prato']");
    By campoMesCardapio = By.xpath("//div[@id = 'dataCardapio']");
    By mesCardapio = By.xpath("//div[text() = 'Abr']");
    By dtInicioDestino = By.xpath("//input[@id = 'DTINIDEST']");
    By ckeckBoxCopiaComCardapioOrig = By.xpath("//label[@class = 'zh-box-label']//span[@zh-icon = 'checked no-border']");
    By tipoPratoAcrescentar = By.xpath("//div[@name = 'tipoPratoAcrescentar']");
    By marcaTipoPrato = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]/div");
    By btnOK = By.xpath("//*[@id='footer']//div[@class = 'zh-footer-right']");
    By btnImportarTipoPrato = By.xpath("//span[text() = 'Importar']");
    By confirmaImportacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");


    //Excluir Cadápio no Período
    By btnExcluirCardapioPeriodo = By.xpath("//span[text() = 'Excluir Cardápio no Período']");
    By limpaDataInicial = By.xpath("//div[@class = 'zh-select-date zh-field-dataInicial']//div[@class = 'close-button']");
    By limpaDataFinal = By.xpath("//div[@class = 'zh-select-date zh-field-dataFinal']//div[@class = 'close-button']");
    By dataInicial = By.xpath("//input[@id = 'dataInicial']");
    By dataFinal = By.xpath("//input[@id = 'dataFinal']");
    By listaTipoPrato = By.xpath("//div[@name = 'listaTipoPrato']");
    By checkTipoPratoTodos = By.xpath("//div[@class='zh-theader zh-ripple-effect']");
    By btnExcluir = By.xpath("//li[@data-zh-id='211546353742575670181035']//span[text() = 'Excluir']");
    By confirmaExclusaoCardPeriodo = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");


    //COnfigurar Cardápio
    By btnConfigurarCardapio = By.xpath("//span[text() = 'Configurar Cardápio']");
    By tipoDePrato1 = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section[2]/section/div/div/div/div/ul/li[2]/div/span[1]/span[1]");
    By tipoDePrato2 = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section[2]/section/div/div/div/div/ul/li[3]/div/span[1]/span[1]");
    By tipoDePrato3 = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section[2]/section/div/div/div/div/ul/li[4]/div/span[1]/span[1]");
    By btnExcluirTipoPratos = By.xpath("//li[@data-zh-id='149407725714901091541629']");
    By btnConfirma = By.xpath("//span[text() = 'Confirmar']");
    By btnOkAlertMensagem = By.xpath("//button[@class= 'zh-alert-button']");

    //Inverter Pratos
    By btnInverterPrato = By.xpath("//span[text() = 'Inverter Prato']");
    By dtPratoOrigem = By.xpath("//input[@id = 'dataCardapioOrig']");
    By dtPratoDestino = By.xpath("//input[@id = 'dataCardapioDest']");
    By ckeckBoxManterComensalDia = By.xpath("//label[@class = 'zh-box-label']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnInverter = By.xpath("//span[text() = 'Inverter']");
    By prato_01 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[3]");
    By prato_02 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[2]/div[3]");

    //Excluir Prato
    By btnExcluirPrato = By.xpath("//li[@data-zh-id='21154635371281162229416']");
    By btnConfirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By getAlertSucessoPlanejamentoExclusao = By.xpath("//ul[@class='zh-notification-messages']");

    //Informação nutricional
    By btnInformacaoNutricional = By.xpath("//li[@data-zh-id='21154635371738403281418']");

    //Revisar Receita
    By btnRevisarReceita = By.xpath("//li[@data-zh-id='21154635371785637359420']");
    By btnReceitaPadrao = By.xpath("//a[text() = 'Receita Padrão']");
    By btnReceitaLocal = By.xpath("//a[text() = 'Receita Local']");
    By btnReceitaPorServico = By.xpath("//a[text() = 'Receita por Serviço']");
    By btnImportarReceita = By.xpath("//li[@data-zh-id='2115463537589168631518']");
    By btnImportarReceitaServico = By.xpath("//li[@data-zh-id='21154635372393255248520']");
    By tipoReceita = By.xpath("//span[@class = 'current']");
    By opcaoPadrao = By.xpath("//li[text() = 'Padrão']");
    By opcaoLocal = By.xpath("//li[text() = 'Local']");
    By opcaoServico = By.xpath("//li[text() = 'Serviço']");
    By campoUnidade = By.xpath("//*[@id='NMFILIAL']/input");
    By defineServico = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMSERVICO zh-text-align-left']");
    By produtoReceitaLocal = By.xpath("//*[@id='grid-21154635373069736250507']/div[2]/div/div[1]/div[1]/span");
    By produtoReceitaPorServico = By.xpath("//*[@id='grid-21154635373870135445559']/div[2]/div/div/div[1]/span");

    By filialOrigem = By.xpath("//span[@data-item-identifier='0003 | DEPOSITO BC 111']");
    By btnRealizaImportacao = By.xpath("//li[@data-zh-id='21154635371080349298656']");
    By importacaoAcrescentar = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Acrescentar']");
    By importacaoSobrepor = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sobrepor']");
    By importacaoCancelar = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Cancelar']");
    By validaPratoCardapio = By.xpath("//div[@class = 'tr cell1']//span[text() = '100 - ARROZ TEMPEREADO']");
    By btnAdicionarProdutoReceitaLocal = By.xpath("//li[@data-zh-id='21154635371309245167554']");
    By btnAdicionarProdutoReceitaPorServico = By.xpath("//li[@data-zh-id='21154635371674637949606']");
    By buscaProdutoLocal = By.xpath("//div[@id = 'NMPRODUTO']//span[@zh-icon='no-border search']");
    By informaBusca = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By buscaUnidadeProduto = By.xpath("//div[@id = 'SGUNIDADE']//span[@zh-icon='no-border search']");
    By checkBoxQtdFixa = By.xpath("//label[@for = 'zh-checkbox-IDQTDEFIXLO']/div[1]");
    By checkBoxQtdFixaServico = By.xpath("//label[@for = 'zh-checkbox-IDQTDEFIXSE']/div[1]");
    By qtdBruta = By.xpath("//input[@name = 'QTBRUTALOUNR']");
    By qtdBrutaServico = By.xpath("//input[@name = 'QTBRUTASEUNR']");
    By ganhoCoccao = By.xpath("//input[@name = 'VRPEFATCOCLO']");
    By ganhoCoccaoServico = By.xpath("//input[@name = 'VRPEFATCOCSE']");
    By perdaLimpeza = By.xpath("//input[@name = 'VRPEFATCORLO']");
    By aprovacaoLimpeza = By.xpath("//input[@name = 'VRPEFATCORLOAP']");
    By valorDegelo = By.xpath("//input[@name = 'VRPERCDEGELO']");
    By valorTempo = By.xpath("//input[@name = 'HRTEMPPREPLO']");
    By checkBoxPrBase = By.xpath("//label[@for = 'zh-checkbox-IDPRODBASELO']/div[1]");
    By aprovacaoNutricional = By.xpath("//input[@name = 'VRPEFATNUTLO']");
    By btnSalvarProduto = By.xpath("//span[text() = 'Salvar']");

    //Retorna produto igual sendo cadastrado

    By retornaMensagemEsperada = By.xpath("/html/body/span[1]/section/section/div[2]/aside[1]/aside/section/aside/div/p");

    //Campos obrigatórios

    By validacaoNomeProduto = By.xpath("/html/body/span[1]/section/section/div[2]/section[3]/div[3]/div[4]/section/section/div/section/div/form/section/div/div[1]/div/div/div[2]/span");
    By validacaoUnidade = By.xpath("//div[@data-zh-id='21154635372073039566568']/div[2]/span");
    By validacaoQtdeBruta = By.xpath("//div[@data-zh-id='21154635372061974844583']/div[2]/span");
    By validacaoGanhoCoccao = By.xpath("//div[@data-zh-id='21154635372393951604574']/div[2]/span");
    By validacaoAprovCoccao = By.xpath("//div[@data-zh-id='2115463537637716888576']/div[2]/span");
    By validacaoPerdaLimpeza = By.xpath("//div[@data-zh-id='21154635371276409651578']/div[2]/span");
    By validacaoAprovLimpeza= By.xpath("//div[@data-zh-id='21154635371596073225580']/div[2]/span");
    By validacaoDegelo = By.xpath("//div[@data-zh-id='21154635372013340627210']/div[2]/span");
    By validacaoDAprovNutricional = By.xpath("//div[@data-zh-id='2115463537878298048586']/div[2]/span");



    public void clicaMenu() {
        tempo();
        waitForElement(ClicaMenu);
       // waitForElement(usernameLoginInfoTextArea);
        click(ClicaMenu);
    }

    public void buscaTelaElaboracao() {
        click(clicaProcurarTela);
        clearAndSendKeys(clicaProcurarTela,"Elaboração do Cardápio");
        tempo();
        click(clicaPlanejamento);
        tempo();
    }

    public String validaAcessoTela(){
        return getText(msgEncontrata);
    }

    public void limparCamposTela(){
        tempo();
        click(btnLimpaCampo);
        click(msgAlerta);
        click(limpaDataCardapio);
        click(limpaCustoPla);
        click(limpaCustoReal);
        click(limpaDataReferencia);
        tempo();
        click(btnConfirma);
        tempo();

    }

    public String mensagemCampoUnidade(){
        return getText(msgCampoUnidade);

    }

    public String mensagemCampoServico(){
        return getText(msgCampoServico);

    }

    public String mensagemCampoMesCard(){
        return getText(msgCampoMesCardapio);

    }

    public String mensagemCustoPla(){
        return getText(msgCustoPla);

    }

    public String mensagemCustoReal(){
        return getText(msgCustoReal);

    }

    public String mensagemCampoDataRef(){
        return getText(msgCampoDataRef);

    }

    public void filtrarUnidade(String CDFILIAL) {
        click(btnLimpaCampo);
        click(msgAlerta);
        click(lupaFilial);
        tempo();
        click(lupaFiltro);
        sendKeys(preencheFilial, CDFILIAL);
        tempo();
        click(confirmaFilial);
        tempo();
    }

    public void filtrarServico(String CDSERVICO) {
        click(filtroServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
        tempo();
    }

    public void definePeriodo() {
        click(campoData);
        click(avancaPeriodo);
        click(periodoCardapio);
        tempo();
    }

    public void montaCardapioAtraves(String tipoMontagem){
        if (tipoMontagem == "P"){
            click(radioPercentualConsumo);
        }else{
            click(radioNumeroComensais);
            tempo();
            click(checkBoxArredondaNumeroComensais);
        }
        tempo();

    }

    public void custoCardapioPla() {
        click(campoCustoPla);
        click(lupaCustoPla);
        sendKeys(informaCustoPla, "Custo Médio Bruto Atual");
        tempo();
        click(selecionaCustoPla);
        tempo();
    }

    public void custoCardapioReal() {
        click(campoCustoReal);
        click(lupaCustoReal);
        sendKeys(informaCustoReal, "Custo Médio Bruto Atual");
        tempo();
        click(selecionaCustoReal);


    }

    public void custoCombaseNaData(String CDEXIBECUSTO, String DATATIPOCUSTO, String DTREFERENCIA) {
        if (CDEXIBECUSTO == "S") {
            returnIfElementIsSelected(exibeCustoCardapio);
        }else {
            click(exibeCustoCardapio);
        }
        if (DATATIPOCUSTO == "R"){
            click(dtReferencia);
            click(limpaDtReferencia);
            click(inputDtReferencia);
            sendKeys(inputDtReferencia, DTREFERENCIA);
        }else {
            click(dtCardapio);
            tempo();
        }
    }

    public void confirmaFiltro() {
        click(btnConfirmar);
        tempo();
        waitForElement(msgEsperada);
    }

    public String mensagemEsperada() {
        return getText(msgEsperada);
    }

    public void elaboraCardapio(String NMPRATO1, String NMPRATO2, String NMPRATO3) {
        tempo();
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(nmPrato);
        sendKeys(nmPrato, NMPRATO1);
        click(clicarGrid);
        click(clicaPrato);
        copiaSubsPratoSalvar();
        duploClique(tipoPrato02);
        click(nmPrato);
        sendKeys(nmPrato, NMPRATO2);
        click(clicarGrid);
        click(clicaPrato);
        copiaSubsPratoSalvar();
        duploClique(tipoPrato03);
        tempo();
        click(nmPrato);
        tempo();
        sendKeys(nmPrato, NMPRATO3);
        tempo();
        click(clicarGrid);
        tempo();
        click(clicaPrato);
        copiaSubsPratoSalvar();
        tempo();
        //Barra de Rolagem
        ScrollTela();
        tempo();
    }

    public String retornaCorPratoCardapio(){
        return getText(corPratoCardapio);
    }

    public void copiaSubsPratoSalvar() {
        click(copiarSubsPratoSeg);
        click(copiarSubsPratoTer);
        click(copiarSubsPratoQua);
        click(copiarSubsPratoQuin);
        click(copiarSubsPratoSex);
        click(btnSalvar);
        tempo();
        tempo();
    }

    public void analisarCorCardapio(){
    String corPrato = "#e74c";
    tempo();
    click(btnAcoes);
    tempo();
    click(analiseCor);
    tempo();
    javaScriptExecutor.executeScript("document.querySelector('#grid-21154635373500446320972 > div.body').scroll(0,500)");
    tempo();
    tempo();

    String style = driver.findElement(validaCorCardapio).getAttribute("style");

    if (style.contains("var-color-dish:")) {

        int indice = style.indexOf("var-color-dish:");
        String codigoCor = style.substring(indice + 15, indice + 22);

        Assert.assertEquals(codigoCor, corPrato, "Foi aplicado corretamente a cor no cardápio. ");
    }else{
        Assert.assertEquals(style.contains("var-color-dish:"), true, "Falha ao aplicar cor no cardápio: ");
        }
    }

    public void analiseCustos() {
        click(btnAcoes);
        tempo();
        click(analiseCusto);
        tempo();
        tempo();
        ScrollTelaAnaliseCusto();
        click(abaRealizado);
        tempo();
       /* tempo();
        ScrollTelaAnaliseCusto();*/
        click(abaAcompanhamento);
        tempo();
        tempo();
        scrollAbaAcompanhamento();
        click(abaProdCustoZero);
        tempo();
        tempo();
        scrollAbaProdutoCustoZero();
        tempo();
        click(abaPlanejado);
        tempo();
        click(clicaDiaAnalise);
        tempo();
        click(consumoPorServico);
        tempo();
        click(clicaTipopratoConsumo);
        tempo();
        click(btnVoltar);
        tempo();
        click(clicaTipoPratoConsumo);
        tempo();
        click(btnVoltar);
        tempo();
        click(materiaPrima);
        tempo();
        click(clicaPratoMateriaPrima);
        tempo();
        tempo();
        click(btnVoltar);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnVoltar);
        tempo();


    }

    public void atualizaDataReferencia(String CDSERVICO, String DTREFERENCIA) {
        tempo();
        click(btnAcoes);
        tempo();
        click(atualizaDataRef);
        click(btnTodos);
        click(campoServico);
        // click(lupaFiltro);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmServico);
        click(btnOk);
        click(limpaDataRef);
        click(insereDataReferencia);
        clearAndSendKeys(insereDataReferencia,DTREFERENCIA);
        tempo();
        click(btnAtualizar);
        click(confirmaDataReferencia);
        tempo();
        click(botaoOkMsg);
        tempo();
    }

    public void atualizaDataRecalculoCusto(String CDSERVICO, String DTREFERENCIA) {
        click(btnAcoes);
        tempo();
        click(btnAtualizaDtRecalculoCusto);
        click(btnTodos);
        click(campoServico);
        // click(lupaFiltro);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmServico);
        click(btnOk);
        click(limpaDataRef);
        click(insereDataReferencia);
        clearAndSendKeys(insereDataReferencia,DTREFERENCIA);
        tempo();
        click(btnAtualizar);
        click(confirmaDataReferencia);
        tempo();

    }

    public void consultaNutrientes() {
        click(btnAcoes);
        tempo();
        click(btnConsulaNutriente);
        tempo();
        click(btnCalculaNutriente);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnCalendario);
        tempo();
        click(diaCalculoNutriente);
        tempo();
        click(btnCalculaNutriente);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnVoltar);
        tempo();

    }

    public void copiarPrato(String CDPRATO, String COMENSAISSEG, String COMENSAISTER, String COMENSAISQUA, String COMENSAISQUI, String COMENSAISSEX, String COMENSAISSAB, String COMENSAISDOM, String COMENSAISFER) {
        click(btnAcoes);
        click(btnCopiaPratoComensais);
        click(limpaCampoServico);
        click(lupaPratoOrigem);
        //  click(lupaFiltro);
        click(informaPrato);
        sendKeys(informaPrato, CDPRATO);
        tempo();
        click(selecionaPrato);
        click(comensaisSeg);
        sendKeys(comensaisSeg, COMENSAISSEG);
        click(comensaisTer);
        sendKeys(comensaisTer, COMENSAISTER);
        click(comensaisSQuar);
        sendKeys(comensaisSQuar, COMENSAISQUA);
        click(comensaisQuin);
        sendKeys(comensaisQuin, COMENSAISQUI);
        click(comensaisSex);
        sendKeys(comensaisSex, COMENSAISSEG);
        click(btnAcoes);
        click(btnCopiarPratos);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void copiarComensais(String CDPRATO) {
        click(btnAcoes);
        click(btnCopiaPratoComensais);
        click(lupaPratoOrigem);
        click(informaPrato);
        sendKeys(informaPrato, CDPRATO);
        click(selecionaPrato);
        click(btnAcoes);
        click(btnCopiaComensais);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void exportarCardapio(String CDSERVICO,String TIPOCOPIA, String CDSERVDESTINO) {
        tempo();
        tempo();
        click(btnAcoes);
        click(btnExportarCardapio);
        tempo();
        click(calendarDtRef);
        tempo();
        click(clicaAno);
        tempo();
        click(btnProximoMes);
        tempo();
        click(selecionaMesDestinoExportacao);
        tempo();
        click(periodoInicial);
        tempo();
        click(periodoFinal);
        click(btnOK);
        tempo();
        click(checkBoxCopiarComOrig);
        tempo();
        if (TIPOCOPIA == "Sobrepor"){
            click(radioButtonSobrepor);
        }
        click(marcaServicoDestino);
        tempo();
        click(btnExportar);
        click(confirmaMensagem);
        click(btnVoltar);
        click(limpaFiltroServico);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVDESTINO);
        tempo();
        click(confirmaServico);
        tempo();
        click(limpaDataCardapio);
        click(campoData);
        tempo();
        click(avancaPeriodo);
        click(selecionaMesDestinoExportacao);
        tempo();
        confirmaFiltro();
        tempo();
        tempo();
        ScrollTela();
        tempo();

    }

    public void importarCardapioDia(String CDFILIAL, String CDSERVICO, String CDSERVICOORIGEM, String DTINICIAL, String DTFINAL, String DTDESTINO, String TIPOCOPIA) {
        tempo();
        click(btnAcoes);
        click(btnImportarCardapio);
        click(lupaFilial);
        sendKeys(informaFilial, CDFILIAL);
        tempo();
        click(selecionaFilial);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICOORIGEM);
        tempo();
        click(confirmaServico);
        click(dtInicialOrigem);
        sendKeys(dtInicialOrigem, DTINICIAL);
        click(dtFinalOrigem);
        sendKeys(dtFinalOrigem, DTFINAL);
        click(dtDestino);
        sendKeys(dtDestino, DTDESTINO);

        if (TIPOCOPIA == "Sobrepor"){
            click(radioSobrepor);
        }
        tempo();
        click(btnFiltrar);
        tempo();
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public String msgExcluidoSucesso(){
        return getText(getAlertSucessoPlanejamentoExclusao);
    }

    public void importarTipoPrato(String CDFILIAL, String CDSERVICO, String DTINICIO) {
        click(btnAcoes);
        click(btnImportaTipoPrato);
        click(btnLimpaCampo);
        click(confirmaMensagem);
        click(lupaFilial);
        tempo();
        click(informaFilial);
        sendKeys(informaFilial, CDFILIAL);
        tempo();
        click(confirmaFilial);
        click(confirmaMensagem);
        tempo();
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
        click(confirmaMensagem);
        click(campoMesCardapio);
        click(mudaAnoImportacao);
        tempo();
        click(mesCardapio);
        click(dtInicioDestino);
        sendKeys(dtInicioDestino, DTINICIO);
        click(ckeckBoxCopiaComCardapioOrig);
        click(tipoPratoAcrescentar);
        click(marcaTipoPrato);
        click(btnOK);
        click(btnImportarTipoPrato);
        tempo();
        click(confirmaImportacao);
        tempo();
        click(confirmaMensagem);
        tempo();
        tempo();
        scrillvertival();
        tempo();

    }

    public void excluirCardapioPeriodo(String DTINICIAL, String DTFINAL) {
        tempo();
        click(btnAcoes);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector('#popup > span > section > section > section > div > div').scrollBy(0,100)");
        tempo();
        click(btnExcluirCardapioPeriodo);
        click(limpaDataInicial);
        click(dataInicial);
        sendKeys(dataInicial, DTINICIAL);
        click(limpaDataFinal);
        click(dataFinal);
        sendKeys(dataFinal, DTFINAL);
        click(listaTipoPrato);
        tempo();
        click(checkTipoPratoTodos);
        tempo();
        click(confirmaExclusaoCardPeriodo);
        tempo();
        click(btnOK);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaExclusaoCardPeriodo);
        tempo();
        tempo();
        tempo();

    }

    public void configurarCardapio() {
        tempo();
        click(btnAcoes);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector('#popup > span > section > section > section > div > div').scrollBy(0,100)");
        click(btnConfigurarCardapio);
        tempo();
        click(tipoDePrato1);
        tempo();
        click(tipoDePrato2);
        tempo();
        click(tipoDePrato3);
        tempo();
        click(btnExcluirTipoPratos);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
        tempo();
        if (returnIfElementExists(btnConfirma)){
        click(btnConfirma);
        tempo();
        click(btnOkAlertMensagem);
        tempo();
        click(btnVoltar);
        }else{
            click(btnVoltar);
        }

        tempo();
        tempo();


    }

    public void invertarPrato(String NMPRATO, String NMPRATO01, String DTORIGEM, String DTDESTINO) {
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(nmPrato);
        tempo();
        sendKeys(nmPrato, NMPRATO);
        tempo();
        click(clicarGrid);
        tempo();
        click(clicaPrato);
        click(copiarSubsPratoSeg);
        tempo();
        click(btnSalvar);
        tempo();
        duploClique(tipoPrato05);
        tempo();
        click(nmPrato);
        sendKeys(nmPrato, NMPRATO01);
        tempo();
        click(clicarGrid);
        tempo();
        click(clicaPrato);
        click(copiarSubsPratoTer);
        tempo();
        click(btnSalvar);
        tempo();
        tempo();
        click(btnAcoes);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector('#popup > span > section > section > section > div > div').scrollBy(0,100)");
        click(btnInverterPrato);
        click(dtPratoOrigem);
        sendKeys(dtPratoOrigem, DTORIGEM);
        click(dtPratoDestino);
        sendKeys(dtPratoDestino, DTDESTINO);
        tempo();
        click(ckeckBoxManterComensalDia);
        click(btnInverter);
        click(confirmaMensagem);
        tempo();
        ScrollTela();
        tempo();
        tempo();

    }

    public String msgEsperadaPrato_01(){
        return getText(prato_01);
    }

    public String msgEsperadaPrato_02(){
        return getText(prato_02);
    }

    public void excluirPrato() {
        click(btnVoltar);
        click(limpaFiltroServico);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, "00001");
        tempo();
        click(confirmaServico);
        tempo();
        confirmaFiltro();
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(btnExcluirPrato);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
        tempo();
    }

    public void informacaoNutricional() {
        tempo();
        tempo();
        duploClique(pratoRevisaoLocal);
        tempo();
        click(btnInformacaoNutricional);
        tempo();
        tempo();
        tempo();
        tempo();
        click(btnVoltar);
        tempo();
        click(btnCancelar);
        tempo();

    }

    public void adicionarProdutoReceita(String tipoReceita){
        tempo();
        if (tipoReceita == "Local") {
            duploClique(pratoRevisaoLocal);
            click(btnRevisarReceita);
            click(btnReceitaLocal);
            tempo();
            click(btnAdicionarProdutoReceitaLocal);
            tempo();
            tempo();
            click(buscaProdutoLocal);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, "CREOSOTO");
            tempo();
            click(selecionaBusca);
            tempo();
            click(buscaUnidadeProduto);
            tempo();
            click(selecionaBusca);
            tempo();
            click(checkBoxQtdFixa);
            click(qtdBruta);
            clearAndSendKeys(qtdBruta, "0,210");
            tempo();
            click(ganhoCoccao);
            clearAndSendKeys(ganhoCoccao, "1");
            tempo();
            click(perdaLimpeza);
            clearAndSendKeys(perdaLimpeza, "5");
            tempo();
            click(valorDegelo);
            clearAndSendKeys(valorDegelo, "5");
            tempo();
            click(valorTempo);
            clearAndSendKeys(valorTempo, "0010");
            tempo();
            click(checkBoxPrBase);
            tempo();
            click(btnSalvarProduto);
            tempo();
            click(btnVoltar);
            tempo();
        }else{
            duploClique(tipoPrato01);
            click(btnRevisarReceita);
            click(btnReceitaPorServico);
            tempo();
            click(btnAdicionarProdutoReceitaPorServico);
            tempo();
            click(buscaProdutoLocal);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, "CREOSOTO");
            tempo();
            click(selecionaBusca);
            tempo();
            click(buscaUnidadeProduto);
            tempo();
            click(selecionaBusca);
            tempo();
            click(checkBoxQtdFixaServico);
            tempo();
            click(qtdBrutaServico);
            clearAndSendKeys(qtdBrutaServico,"0,120");
            tempo();
            click(ganhoCoccaoServico);
            clearAndSendKeys(ganhoCoccaoServico,"2");
            tempo();
            click(btnSalvarProduto);
            tempo();
            click(btnVoltar);
            tempo();
            }
        }

    public void validaCadastroProdutoIgual(String tipoReceita){
        if (tipoReceita == "Local") {
            tempo();
            duploClique(pratoRevisaoLocal);
            click(btnRevisarReceita);
            click(btnReceitaLocal);
            tempo();
            click(btnAdicionarProdutoReceitaLocal);
            tempo();
            tempo();
            click(buscaProdutoLocal);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, "FEIJAO CARIOCA TIPO 1 1KG");
            tempo();
            click(selecionaBusca);
            tempo();
            click(buscaUnidadeProduto);
            tempo();
            click(selecionaBusca);
            tempo();
            click(checkBoxQtdFixa);
            click(qtdBruta);
            clearAndSendKeys(qtdBruta, "0,210");
            click(btnSalvar);
            tempo();
            Assert.assertEquals(validaCadastroProdutoIgual(),"Impossível adicionar. Registro já existe.","Foi identificada falha na receita local: ");
            click(btnOkAlertMensagem);
            tempo();
            click(btnCancelar);
            tempo();
        }else{
            tempo();
            duploClique(tipoPrato01);
            click(btnRevisarReceita);
            click(btnReceitaPorServico);
            tempo();
            click(btnAdicionarProdutoReceitaPorServico);
            tempo();
            click(buscaProdutoLocal);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, "OLEO DE CASTANHA DO BRASIL");
            tempo();
            click(selecionaBusca);
            tempo();
            click(buscaUnidadeProduto);
            tempo();
            click(selecionaBusca);
            tempo();
            click(checkBoxQtdFixaServico);
            tempo();
            click(qtdBrutaServico);
            clearAndSendKeys(qtdBrutaServico,"0,120");
            tempo();
            click(btnSalvar);
            tempo();
            Assert.assertEquals(validaCadastroProdutoIgual(),"Impossível adicionar. Registro já existe.","Foi identificada falha na receita por serviço: ");
            click(btnOkAlertMensagem);
            tempo();
            click(btnCancelar);
            tempo();
        }
    }

    public String validaCadastroProdutoIgual(){
        return getText(retornaMensagemEsperada);

    }

    public String retornarProdutoCadastrado(String tipoReceita){
        if (tipoReceita == "Local") {
            tempo();
            return getText(produtoReceitaLocal);
        }else {
            tempo();
            return getText(produtoReceitaPorServico);
        }
    }

    public void revisaoReceitaLocal(String acaoRevisao) {
        tempo();
        duploClique(pratoRevisaoLocal);
        click(btnRevisarReceita);
        click(btnReceitaLocal);
        tempo();
        click(btnImportarReceita);
        click(tipoReceita);
        tempo();
        click(opcaoPadrao);
        tempo();
        click(btnRealizaImportacao);
        tempo();
        if (acaoRevisao == "Acrescentar") {
            click(importacaoAcrescentar);
        }else {
            click(importacaoSobrepor);
        }
        tempo();
        click(btnVoltar);
        click(btnSalvar);
        tempo();
    }

    public void revisaoReceitaPorServico(String acaoRevisao) {
        Actions actions = new Actions(driver);
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(btnRevisarReceita);
        click(btnReceitaPorServico);
        tempo();
        click(btnImportarReceitaServico);
        click(tipoReceita);
        tempo();
        click(opcaoLocal);
        tempo();
        actions.moveToElement(driver.findElement(campoUnidade), -100, 0).click().build().perform();
        tempo();
        click(filialOrigem);
        tempo();
        click(btnRealizaImportacao);
        tempo();
        if (acaoRevisao == "Acrescentar") {
            click(importacaoAcrescentar);
        }else{
            click(importacaoSobrepor);
        }
        tempo();
        click(btnVoltar);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String validaPratoCardapio(){
        return getText(validaPratoCardapio);
    }

    public void validarCamposObrigatorios(){
        String mensagem = "";
        validaMensagemCamposObrigatorio(validacaoNomeProduto,mensagem);
    }

}