package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MedicaoEfetivosPage extends PageBase {

    By ClicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By ClicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By ClicaMedicao = By.xpath("//span[text() = 'Medição']");
    By medicaoEfetivos = By.xpath("//span[text() = 'Medição de Efetivos']");
    By limpaFiltro = By.xpath("//*[@zh-icon='no-border close-x']");
    By filtroUnidade = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon = 'no-border search']");
    By inputUnidade = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By clicaUnidade = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By limpaData = By.xpath("//div[@class = 'zh-select-date zh-field-DTCARDAPIO']//span[@zh-icon = 'no-border close-x']");
    By dtEfetivo = By.xpath("//input[@id = 'DTCARDAPIO']");
    By grupServico = By.xpath("//div[@id= 'NMGRUPSERV']");
    By selecionaServico = By.xpath("//div[@id= 'NMSERVICO']");
    By btnAplicarFiltro = By.xpath("//section[@class = 'popup-container']//span[text() = 'Aplicar filtro']");


    //Lançando Efetivos Planejamento
    By qtdCliente = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[3]");
    By insertQtd = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[3]/div/input");
    By qtdFuncionario = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[4]/div");
    By insertQtdFunc = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[4]/div/input");
    By qtdDoacao = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[5]/div");
    By insertQtdDoacao = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[5]/div/input");
    By btnSalvarAlteracao = By.xpath("//span[text() = 'Salvar alterações']");
    By clicaServico = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[1]");

    // Lançando Efetivos Faturamento
    By qtdCLienteFatu  = By.xpath("//*[@id='grid-350544352968807824104']/div[2]/div/div/div[4]/div");
    By insertEfetivoFatu = By.xpath("//*[@id='grid-350544352968807824104']/div[2]/div/div/div[4]/div/input");
    By qtdVendaVista = By.xpath("//*[@id='grid-350544352968807824104']/div[2]/div/div/div[6]");
    By insertEfetVendaVista = By.xpath("//*[@id='grid-350544352968807824104']/div[2]/div/div/div[6]/div/input");
    By btnRateio = By.xpath("//li[@data-zh-id='3505443522134108253512']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");
    By msgAlerta = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'OK']");

    //Validando campos
    By msgEncontradaEfetivosCliente = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[3]/span");
    By msgEncontradaEfetivosFuncionario = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[4]/span");
    By msgEncontradaEfetivosDoacao = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[5]/span");
    By msgEncontradaEfetivosTotal = By.xpath("//*[@id='grid-35054435228195666132480']/div[2]/div/div/div[6]/span");
    By msgEncontradaEfetivosFatu = By.xpath("//*[@id='grid-350544352968807824104']/div[2]/div/div/div[4]/span");


    //Emitindo relatórios
    By btnRelatorio = By.xpath("//span[text() = 'Relatório']");
    By limpaFiltroRel = By.xpath("//*[@name='REPORT_NAME']");
    By buscaRel = By.xpath("//*[@id='REPORT_NAME']/span");
    By minimizaBusca = By.xpath("//*[@id='popup']/span/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/span[1]");
    By relMedicaoRFC = By.xpath("//div[@class = 'row col-xs-12 zh-first-large']//span[text() = 'Conhecimento do Fornecimento de Refeições (R.F.C.)']");
    By relMedicaoEfetivos = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Medição de Efetivos por Serviço']");
    By relMedicaoPorData = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Medição de Efetivos por Data']");
    By relMedicaoPorPrato = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Medição de Efetivos por Prato (por Serviço)']");
    By relMedicaoPorPratoData =  By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Medição de Efetivos por Prato (por Data)']");
    By relMedicaoEfetPorPrato = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Medição de Efetivos por Prato (por Data / Prato)']");
    By relMedicaoporPratoPorData = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Medição de Efetivos por Prato (por Prato / Data)']");
    By relLogAlteracao = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Log de Alteração de Efetivos']");
    By relCfrSintetico = By.xpath("//section[@data-ng-if= 'popupOpen']//span[text() = 'Conhecimento do Fornecimento de Refeições (Sintético)']");
    By campoUnidade = By.xpath("//div[@id= 'NMFILIAL']//span[@zh-icon='no-border close-x']");
    By informaBusca = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By dtInicial = By.xpath("//input[@id = 'PERIODO_START']");
    By dtFinal = By.xpath("//input[@id = 'PERIODO_END']");
    By emiteRel = By.xpath("//li[@data-zh-id='799047503727133531535']//span[text() = 'Relatório']");
    By btnConfirmar = By.xpath("//section[@class = 'popup-container']//span[text() = 'Confirmar']");


    public void filtroEfetivos(String unidade, String data){
        tempo();
        click(ClicaMenu);
        click(ClicaPlanejamento);
        click(ClicaMedicao);
        click(medicaoEfetivos);
        tempo();
        tempo();
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade, unidade);
        click(clicaUnidade);
        click(limpaData);
        click(dtEfetivo);
        sendKeys(dtEfetivo, data);
        tempo();
        click(btnAplicarFiltro);
        tempo();
    }

    public void informaQtdEfetivos(String QTDCLIENTE, String QTDFUNCIONARIO, String QTDDOACAO){
        click(qtdCliente);
        click(insertQtd);
        sendKeys(insertQtd, QTDCLIENTE);
        tempo();
        click(qtdFuncionario);
        sendKeys(insertQtdFunc, QTDFUNCIONARIO);
        tempo();
        click(qtdDoacao);
        sendKeys(insertQtdDoacao,QTDDOACAO);
        click(btnSalvarAlteracao);
       // click(clicaServico);
        tempo();
    }

    public void efetivosFaturamento(String QTDEFETIVOFATU, String QTDVENDAVISTA, String QTDATUAL){
        click(qtdCLienteFatu);
        click(insertEfetivoFatu);
        sendKeys(insertEfetivoFatu,QTDEFETIVOFATU);
        click(qtdVendaVista);
        click(insertEfetVendaVista);
        sendKeys(insertEfetVendaVista, QTDVENDAVISTA);
        tempo();
        click(btnRateio);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnSalvarAlteracao);
        tempo();
        aceitaMensagem();
        tempo();
        click(qtdCLienteFatu);
        clearAndSendKeys(insertEfetivoFatu,QTDATUAL);
        click(btnSalvarAlteracao);
        tempo();
        click(btnVoltar);
        tempo();
    }

    public void aceitaMensagem(){
        click(msgAlerta);
    }

    public void emiteReltorio(String nomeRelatorio){
        click(btnRelatorio);
        tempo();
        click(limpaFiltroRel);
        click(buscaRel);
        tempo();
        switch (nomeRelatorio) {
            case "Conhecimento do Fornecimento de Refeições (R.F.C.)":
            click(relMedicaoRFC);
            break;
            case "Medição de Efetivos por Serviço":
                click(relMedicaoEfetivos);
                break;
            case "Medição de Efetivos por Data":
                click(relMedicaoPorData);
                break;
            case "Medição de Efetivos por Prato (por Serviço)":
                click(relMedicaoPorPrato);
                break;
            case "Medição de Efetivos por Prato (por Data)":
                click(relMedicaoPorPratoData);
                break;
            case "Medição de Efetivos por Prato (por Data / Prato)":
                click(relMedicaoEfetPorPrato);
                break;
            case "Medição de Efetivos por Prato (por Prato / Data)":
                click(relMedicaoporPratoPorData);
                break;
            case "Log de Alteração de Efetivos":
                click(relLogAlteracao);
                break;
            case "Conhecimento do Fornecimento de Refeições (Sintético)":
                click(relCfrSintetico);
                break;
        }
    }

    public void filtrarUnidade(String CDUNIDADE){
        tempo();
        click(campoUnidade);
        click(filtroUnidade);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,CDUNIDADE);
        tempo();
        click(selecionaBusca);
    }

    public void definirPeriodo(String DTINICIAL, String DTFINAL){
        preencheData(DTINICIAL,DTFINAL,dtInicial,dtFinal);
        tempo();
        click(emiteRel);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
    }

    public String efetivosCliente(){
        return getText(msgEncontradaEfetivosCliente);
    }
    public String efetivosFuncionario(){
        return getText(msgEncontradaEfetivosFuncionario);
    }
    public String efetivosDoacao(){
        return getText(msgEncontradaEfetivosDoacao);
    }
    public String efetivosTotal(){
        return getText(msgEncontradaEfetivosTotal);
    }
    public String efetivosFaturamento(){
        click(clicaServico);
        tempo();
        return getText(msgEncontradaEfetivosFatu);
    }

    public void zerarQtdEfetivos(){
        tempo();
        click(qtdCliente);
        click(insertQtd);
        sendKeys(insertQtd, "0");
        tempo();
        click(qtdFuncionario);
        sendKeys(insertQtdFunc, "0");
        tempo();
        click(qtdDoacao);
        sendKeys(insertQtdDoacao,"0");
        click(btnSalvarAlteracao);
        tempo();
        click(qtdCLienteFatu);
        click(insertEfetivoFatu);
        sendKeys(insertEfetivoFatu,"0");
        click(qtdVendaVista);
        click(insertEfetVendaVista);
        sendKeys(insertEfetVendaVista, "0");
        tempo();
        click(btnSalvarAlteracao);
        tempo();
        click(btnVoltar);
        tempo();
    }





}
